diff --git a/hgext/inotify/client.py b/hgext/inotify/client.py
--- a/hgext/inotify/client.py
+++ b/hgext/inotify/client.py
@@ -29,7 +29,7 @@ def query(ui, repo, names, match, ignore
         states = 'almrx!'
         if ignored:
             raise ValueError('this is insanity')
-        if clean: states += 'n'
+        if clean: states += 'c'
         if unknown: states += '?'
         yield states
 
diff --git a/tests/test-inotify b/tests/test-inotify
new file mode 100755
--- /dev/null
+++ b/tests/test-inotify
@@ -0,0 +1,30 @@
+#!/bin/sh
+
+"$TESTDIR/hghave" inotify || exit 80
+
+hg init
+
+touch a b c d e
+mkdir dir
+mkdir dir/bar
+touch dir/x dir/y dir/bar/foo
+
+hg ci -Am m
+
+echo "[extensions]" >> $HGRCPATH
+echo "inotify=" >> $HGRCPATH
+
+echo % inserve
+hg inserve -d --pid-file=hg.pid
+cat hg.pid >> "$DAEMON_PIDS"
+
+# let the daemon finish its stuff
+sleep 1
+# issue907
+hg status
+echo % clean
+hg status -c
+echo % all
+hg status -A
+
+kill `cat hg.pid`
diff --git a/tests/test-inotify.out b/tests/test-inotify.out
new file mode 100644
--- /dev/null
+++ b/tests/test-inotify.out
@@ -0,0 +1,29 @@
+adding a
+adding b
+adding c
+adding d
+adding dir/bar/foo
+adding dir/x
+adding dir/y
+adding e
+% inserve
+? hg.pid
+% clean
+C a
+C b
+C c
+C d
+C dir/bar/foo
+C dir/x
+C dir/y
+C e
+% all
+? hg.pid
+C a
+C b
+C c
+C d
+C dir/bar/foo
+C dir/x
+C dir/y
+C e